/*
Copyright by Oleg Efimov and node-mysql-libmysqlclient contributors
See contributors list in README

See license text in LICENSE file
*/

// Load configuration
var cfg = require('../config');

var testCase = require('nodeunit').testCase;

/**
 * @url: https://github.com/Sannis/node-mysql-libmysqlclient/issues#issue/83
 *
 * Look at querySync()/realQuerySync() code for '\0'
 */
module.exports = testCase({
  setUp: function (callback) {
    this.conn = cfg.mysql_libmysqlclient.createConnectionSync(cfg.host, cfg.user, cfg.password, cfg.database);
    
    this.conn.querySync('DROP TABLE IF EXISTS ' + cfg.test_table);
    this.conn.querySync('CREATE TABLE ' + cfg.test_table +
                         ' (vc VARCHAR(8), vb VARBINARY(8), c CHAR(8), b BINARY(8)) ' + cfg.store_engine);
    this.conn.realQuerySync('INSERT INTO ' + cfg.test_table +
                         ' (vc, vb, c, b) VALUES ("qw\u0000rty", "qw\\0rty", "qw\\0rty", "qw\\0rty")');
    callback();
  },
  tearDown: function (callback) {
    //this.conn.querySync("DROP TABLE " + cfg.test_table + ";");
    this.conn.closeSync();
    callback();
  },
  'gh-83': function (test) {
    var rows = this.conn.querySync('SELECT vc, vb, c, b FROM ' + cfg.test_table).fetchAllSync();
    test.done();
  }
});
